"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.parallelTransactionProcessor = exports._TransactionInstructionWithIndex = void 0;
var web3_js_1 = require("@solana/web3.js");
var tools_1 = require("./tools");
var globalTypes_1 = require("./globalTypes");
var _TransactionInstructionWithIndex = /** @class */ (function (_super) {
    __extends(_TransactionInstructionWithIndex, _super);
    function _TransactionInstructionWithIndex(transactionInstruction, signers, index) {
        if (signers === void 0) { signers = []; }
        var _this = _super.call(this, transactionInstruction, signers) || this;
        _this.index = index;
        return _this;
    }
    return _TransactionInstructionWithIndex;
}(globalTypes_1.TransactionInstructionWithSigners));
exports._TransactionInstructionWithIndex = _TransactionInstructionWithIndex;
var timeoutSecs = 90;
var sendTransactionChunk = function (transactionInstructions, wallet, connection) { return __awaiter(void 0, void 0, void 0, function () {
    var block, toSignQueued, signedTxns, sendedTransactionsSignatures;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, connection.getLatestBlockhash('confirmed')];
            case 1:
                block = _a.sent();
                toSignQueued = __spreadArray([], transactionInstructions, true).map(function (tiws) {
                    var transaction = new web3_js_1.Transaction({ feePayer: wallet.publicKey });
                    transaction.add(tiws.transactionInstruction);
                    transaction.recentBlockhash = block.blockhash;
                    if (tiws.signers && tiws.signers.length > 0) {
                        transaction.partialSign.apply(transaction, tiws.signers);
                    }
                    return transaction;
                });
                return [4 /*yield*/, wallet.signAllTransactions(toSignQueued)];
            case 2:
                signedTxns = _a.sent();
                return [4 /*yield*/, Promise.all(signedTxns.map(function (x) {
                        var rawTransaction = x.serialize();
                        return connection.sendRawTransaction(rawTransaction, {
                            skipPreflight: true,
                        });
                    }))];
            case 3:
                sendedTransactionsSignatures = _a.sent();
                return [2 /*return*/, __spreadArray([], sendedTransactionsSignatures.map(function (x, idx) {
                        var nowTimestamp = (0, tools_1.getUnixTs)();
                        return {
                            id: x,
                            timestamp: nowTimestamp,
                            index: transactionInstructions[idx].index,
                            sendedAtBlock: block.lastValidBlockHeight,
                        };
                    }), true)];
        }
    });
}); };
var sendInstructions = function (transactionsWithIndex, batchSize, wallet, connection) { return __awaiter(void 0, void 0, void 0, function () {
    var toConfirm, transactionsChunks, i, sendedTransactions;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                toConfirm = [];
                transactionsChunks = (0, tools_1.chunks)(transactionsWithIndex, batchSize);
                i = 0;
                _a.label = 1;
            case 1:
                if (!(i < transactionsChunks.length)) return [3 /*break*/, 4];
                return [4 /*yield*/, sendTransactionChunk(transactionsChunks[i], wallet, connection)];
            case 2:
                sendedTransactions = _a.sent();
                toConfirm.push.apply(toConfirm, sendedTransactions);
                _a.label = 3;
            case 3:
                i++;
                return [3 /*break*/, 1];
            case 4: return [2 /*return*/, toConfirm];
        }
    });
}); };
/**
 * sign, send and wait for confirmation of parallel transactions, best for in code keypair wallet
 */
var parallelTransactionProcessor = function (_a) {
    var transactionInstructionsWithSigners = _a.transactionInstructionsWithSigners, connection = _a.connection, wallet = _a.wallet, _b = _a.batchSize, batchSize = _b === void 0 ? 50 : _b, _c = _a.maxRetryNumber, maxRetryNumber = _c === void 0 ? 5 : _c;
    return __awaiter(void 0, void 0, void 0, function () {
        var confirmationIntervalPeriod, toConfirmIsEmptyCheckEndThreshold, retryCount, toConfirmIsEmptyCount, startBlockCheck, txWithIdx, toConfirm, notConfirmed, sendedTransactions, done;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    confirmationIntervalPeriod = 5000;
                    toConfirmIsEmptyCheckEndThreshold = 5;
                    retryCount = 0;
                    toConfirmIsEmptyCount = 0;
                    startBlockCheck = false;
                    txWithIdx = transactionInstructionsWithSigners.map(function (x, idx) {
                        return __assign(__assign({}, x), { index: idx });
                    });
                    toConfirm = [];
                    notConfirmed = [];
                    return [4 /*yield*/, sendInstructions(txWithIdx, batchSize, wallet, connection)];
                case 1:
                    sendedTransactions = _d.sent();
                    toConfirm.push.apply(toConfirm, sendedTransactions);
                    return [4 /*yield*/, new Promise(function (resolve) {
                            var maxConfirmBatchSize = 256;
                            var confirmationInterval = setInterval(function () { return __awaiter(void 0, void 0, void 0, function () {
                                var instructionsToRetry, sendedTransactions_1, statusChecks, _a, signatures, block, i, signature, nowTimestamp;
                                var _b;
                                return __generator(this, function (_c) {
                                    switch (_c.label) {
                                        case 0:
                                            if (!toConfirm.length) {
                                                toConfirmIsEmptyCount += 1;
                                            }
                                            else {
                                                toConfirmIsEmptyCount = 0;
                                            }
                                            console.log({
                                                notConfirmed: notConfirmed.length,
                                                toConfirm: toConfirm.length,
                                            });
                                            if (!(toConfirmIsEmptyCount === toConfirmIsEmptyCheckEndThreshold)) return [3 /*break*/, 3];
                                            if (!(!notConfirmed.length || retryCount >= maxRetryNumber)) return [3 /*break*/, 1];
                                            resolve('done');
                                            clearInterval(confirmationInterval);
                                            return [3 /*break*/, 3];
                                        case 1:
                                            instructionsToRetry = notConfirmed.map(function (x) {
                                                return __assign(__assign({}, transactionInstructionsWithSigners[x.index]), { index: x.index });
                                            });
                                            return [4 /*yield*/, sendInstructions(instructionsToRetry, batchSize, wallet, connection)];
                                        case 2:
                                            sendedTransactions_1 = _c.sent();
                                            retryCount += 1;
                                            startBlockCheck = false;
                                            //clear array of not confirmed
                                            notConfirmed.splice(0, notConfirmed.length);
                                            toConfirm.push.apply(toConfirm, sendedTransactions_1);
                                            _c.label = 3;
                                        case 3:
                                            statusChecks = [connection.getSignatureStatuses(__spreadArray([], toConfirm.slice(0, maxConfirmBatchSize).map(function (x) { return x.id; }), true))];
                                            if (startBlockCheck) {
                                                statusChecks.push(connection.getLatestBlockhash('processed'));
                                            }
                                            return [4 /*yield*/, Promise.all(statusChecks)];
                                        case 4:
                                            _a = _c.sent(), signatures = _a[0], block = _a[1];
                                            for (i = 0; i < ((_b = signatures === null || signatures === void 0 ? void 0 : signatures.value) === null || _b === void 0 ? void 0 : _b.length); i++) {
                                                signature = signatures.value[i];
                                                if ((signature === null || signature === void 0 ? void 0 : signature.confirmationStatus) === 'confirmed') {
                                                    //remove item from que
                                                    toConfirm.splice(i, 1);
                                                }
                                                else {
                                                    nowTimestamp = (0, tools_1.getUnixTs)();
                                                    if (nowTimestamp - toConfirm[i].timestamp >= timeoutSecs) {
                                                        startBlockCheck = true;
                                                        console.log(block && block.lastValidBlockHeight, toConfirm[i].sendedAtBlock + tools_1.MAXIMUM_NUMBER_OF_BLOCKS_FOR_TRANSACTION);
                                                        if (block &&
                                                            block.lastValidBlockHeight >= toConfirm[i].sendedAtBlock + tools_1.MAXIMUM_NUMBER_OF_BLOCKS_FOR_TRANSACTION) {
                                                            notConfirmed.push({
                                                                id: toConfirm[i].id,
                                                                index: toConfirm[i].index,
                                                            });
                                                            //remove item from que
                                                            toConfirm.splice(i, 1);
                                                        }
                                                    }
                                                }
                                            }
                                            return [2 /*return*/];
                                    }
                                });
                            }); }, confirmationIntervalPeriod);
                        })];
                case 2:
                    done = _d.sent();
                    return [2 /*return*/, done];
            }
        });
    });
};
exports.parallelTransactionProcessor = parallelTransactionProcessor;
